



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring、Spring MVC、MyBatis整合文件配置详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring、Spring MVC、MyBatis整合文件配置详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 23:20:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>原文&nbsp;&nbsp;<a href="http://www.cnblogs.com/wxisme/p/4924561.html?utm_source=tuicool&amp;utm_medium=referral" rel="external nofollow noreferrer">http://www.cnblogs.com/wxisme/p/4924561.html</a></div>
<div>主题&nbsp;<a href="http://www.tuicool.com/topics/11080033" rel="external nofollow noreferrer">MVC模式</a><a href="http://www.tuicool.com/topics/11070006" rel="external nofollow noreferrer">MyBatis</a><a href="http://www.tuicool.com/topics/11070101" rel="external nofollow noreferrer">Spring MVC</a></div>
</div>
<div>
<div>
<p>使用SSM框架做了几个小项目了，感觉还不错是时候总结一下了。先总结一下SSM整合的文件配置。其实具体的用法最好还是看官方文档。</p>
<p>Spring：&nbsp;<a href="http://spring.io/docs" rel="external nofollow noreferrer">http://spring.io/docs</a></p>
<p>MyBatis：&nbsp;<a href="http://mybatis.github.io/mybatis-3/" rel="external nofollow noreferrer">http://mybatis.github.io/mybatis-3/</a></p>
<p>基本的组织结构和用法就不说了，前面的博客和官方文档上都非常的全面。jar包可以使用Maven来组织管理。来看配置文件。</p>
<p>web.xml的配置</p>
<p>web.xml应该是整个项目最重要的配置文件了，不过servlet3.0中已经支持注解配置方式了。在servlet3.0以前每个servlet必须要在web.xml中配置servlet及其映射关系。但是在spring框架中就不用了，因为Spring中是依赖注入（Dependency Injection）的也叫控制反转（Inversion of Control）。但是也要配置一个重要的servlet，就是前端控制器（DispatcherServlet）。配置方式与普通的servlet基本相似。</p>
<p>配置内容如下：</p>
<pre class="prettyprint linenums">&lt;!-- 配置前端控制器 --&gt;<br />
&lt;servlet&gt;<br />
  &lt;servlet-name&gt;spring&lt;/servlet-name&gt;<br />
  &lt;servlet-class&gt;org.springframework.web.servlet.DispatcherServlet&lt;/servlet-class&gt;<br />
  &lt;init-param&gt;<br />
    &lt;!-- ContextconfigLocation配置springmvc加载的配置文件<br />
    适配器、处理映射器等<br />
     --&gt;<br />
    &lt;param-name&gt;contextConfigLocation&lt;/param-name&gt;<br />
    &lt;param-value&gt;WEB-INF/classes/spring/springmvc.xml&lt;/param-value&gt;<br />
&lt;/init-param&gt;<br />
&lt;/servlet&gt;<br />
&lt;servlet-mapping&gt;<br />
  &lt;servlet-name&gt;spring&lt;/servlet-name&gt;<br />
  &lt;!-- 1、.action访问以.action结尾的  由DispatcherServlet进行解析<br />
     2、/,所有访问都由DispatcherServlet进行解析<br />
   --&gt;<br />
  &lt;url-pattern&gt;/&lt;/url-pattern&gt;<br />
&lt;/servlet-mapping&gt;
</pre>
<p>这里需要注意，springmvc.xml是spring配置文件，将在后面讨论。在&lt;servlet-mapping&gt;中url如果是.action，前端控制器就只会拦截以.action结尾的请求，并不会理会静态的文件。对静态页面的控制就要通过其他的手段。以/作为url的话就会拦截所有的请求，包括静态页面的请求。这样的话就可以拦截任何想要处理的请求，但是有一个问题。如果拦截了所有的请求，如果不在拦截器中做出相应的处理那么所有静态的js、css以及页面中用到的图片就会访问不到造成页面无法正常显示。但这可以通过静态资源的配置来解决这个问题。后面会提到。</p>
<p>配置spring容器：</p>
<pre class="prettyprint linenums">&lt;context-param&gt;<br />
        &lt;param-name&gt;contextConfigLocation&lt;/param-name&gt;<br />
        &lt;param-value&gt;WEB-INF/classes/spring/applicationContext-*.xml&lt;/param-value&gt;

&lt;/context-param&gt;</pre>
<p>其中applicationContext-*.xml包含3个配置文件，是springIoC容器的具体配置。后面会提到。</p>
<p>配置一个监听器：</p>
<pre class="prettyprint linenums">&lt;listener&gt;<br />
        &lt;listener-class&gt;org.springframework.web.context.ContextLoaderListener&lt;/listener-class&gt;<br />
&lt;/listener&gt;</pre>
<p>web.xml的完整配置是这样的：</p>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;web-app version="3.0"<br />
  xmlns="http://java.sun.com/xml/ns/javaee"<br />
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
  xsi:schemaLocation="http://java.sun.com/xml/ns/javaee<br />
  http://java.sun.com/xml/ns/javaee/web-app_3_0.xsd"&gt;<br />
  &lt;display-name&gt;&lt;/display-name&gt;<br />
  &lt;!-- 404错误拦截 --&gt;<br />
  &lt;error-page&gt;<br />
  &lt;error-code&gt;404&lt;/error-code&gt;<br />
  &lt;location&gt;/error404.jsp&lt;/location&gt;<br />
  &lt;/error-page&gt;<br />
  &lt;!-- 500错误拦截 --&gt;<br />
  &lt;error-page&gt;<br />
  &lt;error-code&gt;500&lt;/error-code&gt;<br />
  &lt;location&gt;/error500.jsp&lt;/location&gt;<br />
  &lt;/error-page&gt;<br />
  &lt;!-- 加载spring容器 --&gt;<br />
  &lt;context-param&gt;<br />
    &lt;param-name&gt;contextConfigLocation&lt;/param-name&gt;<br />
    &lt;param-value&gt;WEB-INF/classes/spring/applicationContext-*.xml&lt;/param-value&gt;<br />
  &lt;/context-param&gt;<br />
  &lt;listener&gt;<br />
    &lt;listener-class&gt;org.springframework.web.context.ContextLoaderListener&lt;/listener-class&gt;<br />
  &lt;/listener&gt;<br />
  &lt;!-- 配置前端控制器 --&gt;<br />
  &lt;servlet&gt;<br />
    &lt;servlet-name&gt;spring&lt;/servlet-name&gt;<br />
    &lt;servlet-class&gt;org.springframework.web.servlet.DispatcherServlet&lt;/servlet-class&gt;<br />
    &lt;init-param&gt;<br />
      &lt;!-- ContextconfigLocation配置springmvc加载的配置文件<br />
      适配器、处理映射器等<br />
       --&gt;<br />
      &lt;param-name&gt;contextConfigLocation&lt;/param-name&gt;<br />
      &lt;param-value&gt;WEB-INF/classes/spring/springmvc.xml&lt;/param-value&gt;<br />
  &lt;/init-param&gt;<br />
  &lt;/servlet&gt;<br />
  &lt;servlet-mapping&gt;<br />
    &lt;servlet-name&gt;spring&lt;/servlet-name&gt;<br />
    &lt;!-- 1、.action访问以.action结尾的  由DispatcherServlet进行解析<br />
       2、/,所有访问都由DispatcherServlet进行解析<br />
     --&gt;<br />
    &lt;url-pattern&gt;/&lt;/url-pattern&gt;<br />
  &lt;/servlet-mapping&gt;<br />
  &lt;!-- 解决post乱码问题的过滤器 --&gt;<br />
  &lt;filter&gt;<br />
    &lt;filter-name&gt;CharacterEncodingFilter&lt;/filter-name&gt;<br />
    &lt;filter-class&gt;org.springframework.web.filter.CharacterEncodingFilter&lt;/filter-class&gt;<br />
    &lt;init-param&gt;<br />
      &lt;param-name&gt;encoding&lt;/param-name&gt;<br />
      &lt;param-value&gt;utf-8&lt;/param-value&gt;<br />
    &lt;/init-param&gt;<br />
  &lt;/filter&gt;<br />
  &lt;filter-mapping&gt;<br />
    &lt;filter-name&gt;CharacterEncodingFilter&lt;/filter-name&gt;<br />
    &lt;url-pattern&gt;/*&lt;/url-pattern&gt;<br />
  &lt;/filter-mapping&gt;<br />
  &lt;welcome-file-list&gt;<br />
  &lt;welcome-file&gt;welcome.jsp&lt;/welcome-file&gt;<br />
  &lt;/welcome-file-list&gt;<br />
&lt;/web-app&gt;
</pre>
<p>看到配置文件中多了两块内容，一个是error page是用来友好的处理错误的，可以使用错误代码来区别并跳转到相应的处理页面。这段配置代码最好放到最前面，在前端控制器拦截之前处理。</p>
<p>还有一块内容是一个解决post乱码问题的过滤器，拦截post请求并编码为utf8。</p>
<p>springmvc.xml的配置</p>
<p>视图解析器的配置：</p>
<pre class="prettyprint linenums">&lt;!-- 配置视图解析器 --&gt;<br />
     &lt;bean class="org.springframework.web.servlet.view.InternalResourceViewResolver"&gt;<br />
         &lt;!-- 使用前缀和后缀 --&gt;<br />
         &lt;property name="prefix" value="/"&gt;&lt;/property&gt;<br />
         &lt;property name="suffix" value=".jsp"&gt;&lt;/property&gt;<br />
&lt;/bean&gt;</pre>
<p>在Controller中设置视图名的时候会自动加上前缀和后缀。</p>
<p>Controller的配置</p>
<p>自动扫描方式，扫描包下面所有的Controller，可以使用注解来指定访问路径。</p>
<pre class="prettyprint linenums">&lt;!-- 使用组件扫描的方式可以一次扫描多个Controller --&gt;<br />
&lt;context:component-scan base-package="com.wxisme.ssm.controller"&gt;</pre>
<p>也可以使用单个的配置方式，需要指定Controller的全限定名。</p>
<pre class="prettyprint linenums">&lt;bean name="/queryUser.action" class="com.wxisme.ssm.controller.Controller1"/&gt;</pre>
<p>配置注解的处理器适配器和处理器映射器：</p>
<pre class="prettyprint linenums">&lt;!-- 注解的处理器适配器 --&gt;<br />
&lt;bean class="org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter"/&gt;<br />
&lt;!-- 注解的处理器映射器 --&gt;<br />
&lt;bean class="org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerMapping"/&gt;</pre>
<p>也可以使用下面的简化配置：</p>
<pre class="prettyprint linenums">&lt;!-- 配置注解的处理器映射器和处理器适配器 --&gt;<br />
&lt;mvc:annotation-driven conversion-service="conversionService"&gt;&lt;/mvc:annotation-driven&gt;</pre>
<p>配置拦截器，可以直接定义拦截所有请求，也可以自定义拦截路径。</p>
<pre class="prettyprint linenums">&lt;mvc:interceptors&gt;<br />
    &lt;!-- 直接定义拦截所有请求 --&gt;<br />
    &lt;bean class="com.wxisme.ssm.interceptor.IdentityInterceptor"&gt;&lt;/bean&gt;<br />
        &lt;!-- &lt;mvc:interceptor&gt;<br />
            拦截所有路径的请求   包括子路径<br />
            &lt;mvc:mapping path="/**"/&gt;<br />
            &lt;bean class="com.wxisme.ssm.interceptor.IdentityInterceptor"&gt;&lt;/bean&gt;<br />
        &lt;/mvc:interceptor&gt; --&gt;<br />
    &lt;/mvc:interceptors&gt;</pre>
<p>配置全局异常处理器</p>
<pre class="prettyprint linenums">&lt;!-- 定义全局异常处理器 --&gt;<br />
    &lt;!-- 只有一个全局异常处理器起作用 --&gt;<br />
    &lt;bean id="exceptionResolver" class="com.wxisme.ssm.exception.OverallExceptionResolver"&gt;&lt;/bean&gt;</pre>
<p>配置文件上传数据解析器，在上传文件时需要配置。</p>
<pre class="prettyprint linenums">&lt;!--配置上传文件数据解析器  --&gt;<br />
    &lt;bean id="multipartResolver" class="org.springframework.web.multipart.commons.CommonsMultipartResolver"&gt;<br />
        &lt;property name="maxUploadSize"&gt;<br />
            &lt;value&gt;9242880&lt;/value&gt;<br />
        &lt;/property&gt;<br />
    &lt;/bean&gt;</pre>
<p>还可以配置一些自定义的参数类型，以日期类型绑定为例。</p>
<pre class="prettyprint linenums">&lt;!-- 自定义参数类型绑定 --&gt;<br />
    &lt;bean id="conversionService" class="org.springframework.format.support.FormattingConversionServiceFactoryBean"&gt;<br />
     &lt;property name="converters"&gt;<br />
         &lt;list&gt;<br />
             &lt;!-- 日期类型绑定 --&gt;<br />
             &lt;bean class="com.wxisme.ssm.controller.converter.DateConverter"/&gt;<br />
         &lt;/list&gt;<br />
     &lt;/property&gt;<br />
    &lt;/bean&gt;</pre>
<p>上面提到过如果在配置前端控制器时拦截了所有的请求，不做特殊处理就会导致部分静态资源无法使用。如果是这种情况就可以使用下面的配置来访问静态资源文件。</p>
<pre class="prettyprint linenums">&lt;mvc:resources mapping="/images/**" location="/images/" /&gt;<br />
&lt;mvc:resources mapping="/css/**" location="/css/" /&gt;<br />
&lt;mvc:resources mapping="/js/**" location="/js/" /&gt;<br />
&lt;mvc:resources mapping="/imgdata/**" location="/imgdata/" /&gt;</pre>
<p>也可以使用默认，但是需要在web.xml中配置。</p>
<pre class="prettyprint linenums">&lt;!-- 访问静态资源文件 --&gt;<br />
    &lt;!-- &lt;mvc:default-servlet-handler/&gt; 需要在web.xml中配置--&gt;</pre>
<p>完全可以不拦截所有路径，大可避免这个问题的发生。</p>
<p>完整的配置大概是这样的，需要注意xml文件的命名空间，有时候会有影响的。</p>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
xmlns:context="http://www.springframework.org/schema/context"<br />
xmlns:mvc="http://www.springframework.org/schema/mvc"<br />
xmlns:jdbc="http://www.springframework.org/schema/jdbc"<br />
xmlns:jee="http://www.springframework.org/schema/jee"<br />
xmlns:aop="http://www.springframework.org/schema/aop"<br />
xmlns:tx="http://www.springframework.org/schema/tx"<br />
xsi:schemaLocation="http://www.springframework.org/schema/beans<br />
http://www.springframework.org/schema/beans/spring-beans.xsd<br />
http://www.springframework.org/schema/context<br />
http://www.springframework.org/schema/context/spring-context.xsd<br />
http://www.springframework.org/schema/mvc<br />
http://www.springframework.org/schema/mvc/spring-mvc.xsd<br />
http://www.springframework.org/schema/tx<br />
http://www.springframework.org/schema/tx/spring-tx.xsd<br />
http://www.springframework.org/schema/aop<br />
http://www.springframework.org/schema/aop/spring-aop.xsd"&gt;<br />
   &lt;!-- 配置视图解析器 --&gt;<br />
   &lt;bean class="org.springframework.web.servlet.view.InternalResourceViewResolver"&gt;<br />
     &lt;!-- 使用前缀和后缀 --&gt;<br />
     &lt;property name="prefix" value="/"&gt;&lt;/property&gt;<br />
     &lt;property name="suffix" value=".jsp"&gt;&lt;/property&gt;<br />
   &lt;/bean&gt;<br />
   &lt;!-- 使用组件扫描的方式可以一次扫描多个Controller --&gt;<br />
   &lt;context:component-scan base-package="com.wxisme.ssm.controller"&gt;<br />
   &lt;/context:component-scan&gt;<br />
   &lt;!-- 配置注解的处理器映射器和处理器适配器 --&gt;<br />
  &lt;mvc:annotation-driven conversion-service="conversionService"&gt;&lt;/mvc:annotation-driven&gt;<br />
  &lt;!-- 自定义参数类型绑定 --&gt;<br />
  &lt;bean id="conversionService" class="org.springframework.format.support.FormattingConversionServiceFactoryBean"&gt;<br />
   &lt;property name="converters"&gt;<br />
     &lt;list&gt;<br />
       &lt;!-- 日期类型绑定 --&gt;<br />
       &lt;bean class="com.wxisme.ssm.controller.converter.DateConverter"/&gt;<br />
     &lt;/list&gt;<br />
   &lt;/property&gt;<br />
  &lt;/bean&gt;<br />
  &lt;!-- 访问静态资源文件 --&gt;<br />
  &lt;!-- &lt;mvc:default-servlet-handler/&gt; 需要在web.xml中配置--&gt;<br />
  &lt;mvc:resources mapping="/images/**" location="/images/" /&gt;<br />
  &lt;mvc:resources mapping="/css/**" location="/css/" /&gt;<br />
  &lt;mvc:resources mapping="/js/**" location="/js/" /&gt;<br />
  &lt;mvc:resources mapping="/imgdata/**" location="/imgdata/" /&gt;<br />
  &lt;!-- 定义拦截器 --&gt;<br />
  &lt;mvc:interceptors&gt;<br />
  &lt;!-- 直接定义拦截所有请求 --&gt;<br />
  &lt;bean class="com.wxisme.ssm.interceptor.IdentityInterceptor"&gt;&lt;/bean&gt;<br />
    &lt;!-- &lt;mvc:interceptor&gt;<br />
      拦截所有路径的请求   包括子路径<br />
      &lt;mvc:mapping path="/**"/&gt;<br />
      &lt;bean class="com.wxisme.ssm.interceptor.IdentityInterceptor"&gt;&lt;/bean&gt;<br />
    &lt;/mvc:interceptor&gt; --&gt;<br />
  &lt;/mvc:interceptors&gt;<br />
  &lt;!--配置上传文件数据解析器  --&gt;<br />
  &lt;bean id="multipartResolver" class="org.springframework.web.multipart.commons.CommonsMultipartResolver"&gt;<br />
    &lt;property name="maxUploadSize"&gt;<br />
      &lt;value&gt;9242880&lt;/value&gt;<br />
    &lt;/property&gt;<br />
  &lt;/bean&gt;<br />
  &lt;!-- 定义全局异常处理器 --&gt;<br />
  &lt;!-- 只有一个全局异常处理器起作用 --&gt;<br />
  &lt;bean id="exceptionResolver" class="com.wxisme.ssm.exception.OverallExceptionResolver"&gt;&lt;/bean&gt;<br />
 &lt;/beans&gt;
</pre>
<p>applicationContext-*.xml的配置</p>
<p>applicationContext-*.xml包括三个配置文件，分别对应数据层控制、业务逻辑service控制和事务的控制。</p>
<h4>数据访问层的控制，applicationContext-dao.xml的配置：</h4>
<p>配置加载数据连接资源文件的配置，把数据库连接数据抽取到一个properties资源文件中方便管理。</p>
<p>配置为：</p>
<pre class="prettyprint linenums">&lt;!-- 加载数据库连接的资源文件 --&gt;<br />
&lt;context:property-placeholder location="/WEB-INF/classes/jdbc.properties"/&gt;</pre>
<p>其中jdbc.properties文件的内容如下：</p>
<pre class="prettyprint linenums">jdbc.driver=com.mysql.jdbc.Driver<br />
jdbc.url=jdbc:mysql://localhost:3306/database<br />
jdbc.username=root<br />
jdbc.password=1234</pre>
<p>配置数据库连接池，这里使用的是dbcp，别忘了添加jar包！</p>
<pre class="prettyprint linenums">&lt;!-- 配置数据源   dbcp数据库连接池 --&gt;<br />
&lt;bean id="dataSource" class="org.apache.commons.dbcp2.BasicDataSource" destroy-method="close"&gt;<br />
    &lt;property name="driverClassName" value="${jdbc.driver}"/&gt;<br />
    &lt;property name="url" value="${jdbc.url}"/&gt;<br />
    &lt;property name="username" value="${jdbc.username}"/&gt;<br />
    &lt;property name="password" value="${jdbc.password}"/&gt;<br />
&lt;/bean&gt;</pre>
<p>Spring和MyBatis整合配置，jar包由MyBatis提供。</p>
<p>配置sqlSessionFactory</p>
<pre class="prettyprint linenums">&lt;!-- 配置sqlSessionFactory --&gt;<br />
&lt;bean id="sqlSessionFactory" class="org.mybatis.spring.SqlSessionFactoryBean"&gt;<br />
  &lt;!-- 数据库连接池 --&gt;<br />
  &lt;property name="dataSource" ref="dataSource"/&gt;<br />
  &lt;!-- 加载Mybatis全局配置文件 --&gt;<br />
  &lt;property name="configLocation" value="/WEB-INF/classes/mybatis/SqlMapConfig.xml"/&gt;<br />
&lt;/bean&gt;
</pre>
<p>SqlMapConfig.xml文件是MyBatis的配置文件，后面会提到。</p>
<p>配置Mapper扫描器，扫描mapper包下的所有mapper文件和类，要求mapper配置文件和类名需要一致。</p>
<pre class="prettyprint linenums">&lt;!-- 配置mapper扫描器 --&gt;<br />
&lt;bean class="org.mybatis.spring.mapper.MapperScannerConfigurer"&gt;<br />
    &lt;!-- 扫描包路径，如果需要扫描多个包中间用半角逗号隔开 --&gt;<br />
    &lt;property name="basePackage" value="com.wxisme.ssm.mapper"&gt;&lt;/property&gt;<br />
    &lt;property name="sqlSessionFactoryBeanName" value="sqlSessionFactory"/&gt;<br />
&lt;/bean&gt;</pre>
<p>整个applicationContext-dao.xml配置文件应该是这样的：</p>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
xmlns:context="http://www.springframework.org/schema/context"<br />
xmlns:mvc="http://www.springframework.org/schema/mvc"<br />
xmlns:jdbc="http://www.springframework.org/schema/jdbc"<br />
xmlns:jee="http://www.springframework.org/schema/jee"<br />
xmlns:aop="http://www.springframework.org/schema/aop"<br />
xmlns:tx="http://www.springframework.org/schema/tx"<br />
xsi:schemaLocation="http://www.springframework.org/schema/beans<br />
http://www.springframework.org/schema/beans/spring-beans.xsd<br />
http://www.springframework.org/schema/context<br />
http://www.springframework.org/schema/context/spring-context.xsd<br />
http://www.springframework.org/schema/mvc<br />
http://www.springframework.org/schema/mvc/spring-mvc.xsd<br />
http://www.springframework.org/schema/tx<br />
http://www.springframework.org/schema/tx/spring-tx.xsd<br />
http://www.springframework.org/schema/aop<br />
http://www.springframework.org/schema/aop/spring-aop.xsd"&gt;<br />
&lt;!-- 加载数据库连接的资源文件 --&gt;<br />
&lt;context:property-placeholder location="/WEB-INF/classes/jdbc.properties"/&gt;<br />
&lt;!-- 配置数据源   dbcp数据库连接池 --&gt;<br />
&lt;bean id="dataSource" class="org.apache.commons.dbcp2.BasicDataSource" destroy-method="close"&gt;<br />
  &lt;property name="driverClassName" value="${jdbc.driver}"/&gt;<br />
  &lt;property name="url" value="${jdbc.url}"/&gt;<br />
  &lt;property name="username" value="${jdbc.username}"/&gt;<br />
  &lt;property name="password" value="${jdbc.password}"/&gt;<br />
&lt;/bean&gt;<br />
&lt;!-- 配置sqlSessionFactory --&gt;<br />
&lt;bean id="sqlSessionFactory" class="org.mybatis.spring.SqlSessionFactoryBean"&gt;<br />
  &lt;!-- 数据库连接池 --&gt;<br />
  &lt;property name="dataSource" ref="dataSource"/&gt;<br />
  &lt;!-- 加载Mybatis全局配置文件 --&gt;<br />
  &lt;property name="configLocation" value="/WEB-INF/classes/mybatis/SqlMapConfig.xml"/&gt;<br />
&lt;/bean&gt;<br />
&lt;!-- 配置mapper扫描器 --&gt;<br />
&lt;bean class="org.mybatis.spring.mapper.MapperScannerConfigurer"&gt;<br />
  &lt;!-- 扫描包路径，如果需要扫描多个包中间用半角逗号隔开 --&gt;<br />
  &lt;property name="basePackage" value="com.wxisme.ssm.mapper"&gt;&lt;/property&gt;<br />
  &lt;property name="sqlSessionFactoryBeanName" value="sqlSessionFactory"/&gt;<br />
&lt;/bean&gt;<br />
&lt;/beans&gt;
</pre>
<h4>业务逻辑控制，applicationContext-service.xml的配置：</h4>
<p>这个文件里暂时只需要定义service的实现类即可。</p>
<pre class="prettyprint linenums">&lt;!-- 定义service --&gt;<br />
&lt;bean id="userService" class="com.wxisme.ssm.service.impl.UserServiceImpl"/&gt;</pre>
<p>事务控制，applicationContext-transaction.xml的配置</p>
<p>配置数据源，使用JDBC控制类。</p>
<pre class="prettyprint linenums">&lt;bean id="transactionManager" class="org.springframework.jdbc.datasource.DataSourceTransactionManager"&gt;<br />
    &lt;!-- 配置数据源 --&gt;<br />
    &lt;property name="dataSource" ref="dataSource"/&gt;<br />
&lt;/bean&gt;</pre>
<p>配置通知，事务控制。</p>
<pre class="prettyprint linenums">&lt;!-- 通知 --&gt;<br />
&lt;tx:advice id="txAdvice" transaction-manager="transactionManager"&gt;<br />
  &lt;tx:attributes&gt;<br />
    &lt;!-- 传播行为 --&gt;<br />
    &lt;tx:method name="save*" propagation="REQUIRED"/&gt;<br />
    &lt;tx:method name="insert*" propagation="REQUIRED"/&gt;<br />
    &lt;tx:method name="update*" propagation="REQUIRED"/&gt;<br />
    &lt;tx:method name="delete*" propagation="REQUIRED"/&gt;<br />
    &lt;tx:method name="find*" propagation="SUPPORTS" read-only="true"/&gt;<br />
    &lt;tx:method name="select*" propagation="SUPPORTS" read-only="true"/&gt;<br />
  &lt;/tx:attributes&gt;<br />
&lt;/tx:advice&gt;
</pre>
<p>配置AOP切面</p>
<pre class="prettyprint linenums">&lt;!-- 配置aop  --&gt;<br />
    &lt;aop:config&gt;<br />
        &lt;aop:advisor advice-ref="txAdvice" pointcut="execution(* com.wxisme.ssm.service.impl.*.*(..))"/&gt;<br />
    &lt;/aop:config&gt;</pre>
<p>整个事务控制的配置是这样的：</p>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
xmlns:context="http://www.springframework.org/schema/context"<br />
xmlns:mvc="http://www.springframework.org/schema/mvc"<br />
xmlns:jdbc="http://www.springframework.org/schema/jdbc"<br />
xmlns:jee="http://www.springframework.org/schema/jee"<br />
xmlns:aop="http://www.springframework.org/schema/aop"<br />
xmlns:tx="http://www.springframework.org/schema/tx"<br />
xsi:schemaLocation="http://www.springframework.org/schema/beans<br />
http://www.springframework.org/schema/beans/spring-beans.xsd<br />
http://www.springframework.org/schema/context<br />
http://www.springframework.org/schema/context/spring-context.xsd<br />
http://www.springframework.org/schema/mvc<br />
http://www.springframework.org/schema/mvc/spring-mvc.xsd<br />
http://www.springframework.org/schema/tx<br />
http://www.springframework.org/schema/tx/spring-tx.xsd<br />
http://www.springframework.org/schema/aop<br />
http://www.springframework.org/schema/aop/spring-aop.xsd"&gt;<br />
&lt;!-- 事务控制  对MyBatis操作数据库  spring使用JDBC事务控制类 --&gt;<br />
&lt;bean id="transactionManager" class="org.springframework.jdbc.datasource.DataSourceTransactionManager"&gt;<br />
  &lt;!-- 配置数据源 --&gt;<br />
  &lt;property name="dataSource" ref="dataSource"/&gt;<br />
&lt;/bean&gt;<br />
  &lt;!-- 通知 --&gt;<br />
  &lt;tx:advice id="txAdvice" transaction-manager="transactionManager"&gt;<br />
    &lt;tx:attributes&gt;<br />
      &lt;!-- 传播行为 --&gt;<br />
      &lt;tx:method name="save*" propagation="REQUIRED"/&gt;<br />
      &lt;tx:method name="insert*" propagation="REQUIRED"/&gt;<br />
      &lt;tx:method name="update*" propagation="REQUIRED"/&gt;<br />
      &lt;tx:method name="delete*" propagation="REQUIRED"/&gt;<br />
      &lt;tx:method name="find*" propagation="SUPPORTS" read-only="true"/&gt;<br />
      &lt;tx:method name="select*" propagation="SUPPORTS" read-only="true"/&gt;<br />
    &lt;/tx:attributes&gt;<br />
  &lt;/tx:advice&gt;<br />
  &lt;!-- 配置aop  --&gt;<br />
  &lt;aop:config&gt;<br />
    &lt;aop:advisor advice-ref="txAdvice" pointcut="execution(* com.wxisme.ssm.service.impl.*.*(..))"/&gt;<br />
  &lt;/aop:config&gt;<br />
&lt;/beans&gt;
</pre>
<p>MyBatis的配置</p>
<p>SqlMapConfig.xml的配置 &nbsp;&nbsp;&nbsp;全局setting配置这里省略，数据库连接池在spring整合文件中已经配置，具体setting配置参考官方文档。</p>
<p>别名的定义：</p>
<pre class="prettyprint linenums">&lt;typeAliases&gt;<br />
    &lt;!-- 批量定义别名 ，指定包名，自动扫描包中的类，别名即为类名，首字母大小写无所谓--&gt;<br />
    &lt;package name="com.wxisme.ssm.po"/&gt;<br />
&lt;/typeAliases&gt;</pre>
<p>mapper映射文件的配置：</p>
<pre class="prettyprint linenums">&lt;mappers&gt;<br />
  &lt;!-- 加载映射文件 --&gt;<br />
  &lt;!-- 这里也可以使用class来加载映射文件，前提是：使用mapper代理的方法，遵循规范，<br />
  并且两个文件必须同名且在同一目录<br />
  &lt;mapper class="com.wxisme.mybatis0100.mapper.UserMapper"/&gt;<br />
  基于class加载，可以进行批量加载<br />
  --&gt;<br />
  &lt;!-- 通过扫描包的方式来进行批量加载映射文件 --&gt;<br />
  &lt;package name="com.wxisme.ssm.mapper"/&gt;<br />
&lt;/mappers&gt;
</pre>
<p>整个文件的配置应该是这样的：</p>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;!DOCTYPE configuration<br />
PUBLIC "-//mybatis.org//DTD Config 3.0//EN"<br />
"http://mybatis.org/dtd/mybatis-3-config.dtd"&gt;<br />
&lt;configuration&gt;<br />
&lt;!-- 将数据库连接数据抽取到属性文件中方便测试 --&gt;<br />
&lt;!-- &lt;properties resource="/WEB-INF/classes/jdbc.properties"&gt;&lt;/properties&gt; --&gt;<br />
&lt;!-- 别名的定义 --&gt;<br />
&lt;typeAliases&gt;<br />
  &lt;!-- 批量定义别名 ，指定包名，自动扫描包中的类，别名即为类名，首字母大小写无所谓--&gt;<br />
  &lt;package name="com.wxisme.ssm.po"/&gt;<br />
&lt;/typeAliases&gt;<br />
&lt;!-- 数据库连接用数据库连接池 --&gt;<br />
&lt;mappers&gt;<br />
  &lt;!-- 通过扫描包的方式来进行批量加载映射文件 --&gt;<br />
  &lt;package name="com.wxisme.ssm.mapper"/&gt;<br />
&lt;/mappers&gt;<br />
&lt;/configuration&gt;
</pre>
<p>具体mapper文件的配置，在使用mapper代理的方法时，命名空间需要是对应的Mapper类。</p>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8" ?&gt;<br />
&lt;!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd" &gt;<br />
&lt;mapper namespace="com.wxisme.ssm.mapper.AlbumMapper" &gt;

&lt;/mapper&gt;</pre>
<p>以上只是对SSM框架简单使用时的配置文件，如果需要深入使用或者需要理解其内部机理需要参考官方文档和其源代码。</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvenxo9.html">Machine Learning Algorithms Study Notes&lpar;5&rpar;&mdash;Reinforcement Learning</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mdr1p8.html">Quartz Job基本示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k4kj59.html">Leetcode &num; 169&comma; 229 Majority Element I and II</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq415w3q.html">sql 遍历结果集</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnxn039.html">spring security method security</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xj22g9.html">OpenMp之sections用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdk4w48.html">Java比较器对数组，集合排序一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zwwwz9.html">&lpar;4&rpar;java方法区</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxngxlv8.html">&lbrack;转&rsqb; Spring Boot and React hot loader</a>
		</li>
						<li><a href="https://www.batexi.com/a/950rgo08.html">ios7以上自定义导航栏标题的字体大小及颜色的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yodo08.html">Laravel 5&period;1 ACL权限控制 一</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eywlpe9.html">今天出现了一个问题，Tomcat 进入localhost：8080正常，进入项目内别的页面都是空白页</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z6gk59.html">JAVA8新特性（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pxe148.html">HP ML150 G6 服务器硬件介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2k0wo9.html">PAT甲级1141 Ranking of Institutions</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rne548.html">步步为营-10-string的简单操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll64z6q.html">NAS 百科 &mdash;&mdash; http&colon;&sol;&sol;baike&period;baidu&period;com&sol;item&sol;NAS&percnt;E7&percnt;BD&percnt;91&percnt;E7&percnt;BB&percnt;9C&percnt;E5&percnt;AD&percnt;98&percnt;E5&percnt;82&percnt;A8</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjw06vq.html">神器phpstorm功能具体解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emw7xx9.html">apicloud  基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/953n3n08.html">Android Paging库使用详解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8mzx5rq.html">Scala特性&colon; 隐式转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gkkz08.html">PHP扩展&mdash;&mdash;C扩展实现滚动记录日志</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gkkk78.html">hibernate关联映射学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e27le8.html">&lbrack;Android&rsqb;ListFragment&period;setEmptyText&lpar;&rpar;  抛 java&period;lang&period;IllegalStateException</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxxgojq.html">BZOJ1202 &lbrack;HNOI2005&rsqb;狡猾的商人&amp;amp&semi;&amp;amp&semi;BZOJ3436小K的农场</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvnm5x9.html">JavaWeb---总结&lpar;十八&rpar;JSP属性范围</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e2l6z8.html">iOS qrcode 默认尺寸与修改</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93k47gq.html">SQL Server Transact-SQL 编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq121z49.html">20145212《Java程序设计》实验报告一：Java开发环境的熟悉（Windows&plus;IDE）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9peznk8.html">yourphp点击刷新验证码</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
